# -*- coding: utf-8 -*-

import uno
import unohelper

import traceback
from com.sun.star.lang import XInitialization
from com.sun.star.frame import XDispatchProvider, XDispatch
from com.sun.star.awt.MessageBoxType import MESSAGEBOX
    

# Definiamo un componente con le interfacce XInitialization, XDispatch, XDispatchProvider,
# necessarie al utilizzare del "Protocol Handler"
class PyService(unohelper.Base, XInitialization, XDispatch, XDispatchProvider):
    def __init__(self, ctx):
        self.ctx = ctx
        self.psm = ctx.ServiceManager
        self.tk = self.create("com.sun.star.awt.Toolkit")
        self.desktop = self.create("com.sun.star.frame.Desktop")

    def create(self, service):
        return self.psm.createInstance(service)

    # XInitialization
    def initialize(self, args):
      if len(args) > 0:
         self.frame = args[0]
         self.doc = self.frame

    # XDispatchProvider
    def queryDispatch(self, url, framename, searchflags):
        if url.Protocol == "esempio1:":
            return self
        return None
    def queryDispatches(self, requests):
        pass

    # XDispatch
    def dispatch(self, url, args):
        try:
            msg = ("Item url protocol: <{}> .\n"
                   "Item url path: <{}> .").format(url.Protocol, url.Path)
            self.msgbox(msg)
        except:
            self.msgbox(traceback.format_exc())

    def addStatusListener(self, control, url):
        pass
    def removeStatusListener(self, control, url):
        pass

    # altri
    def msgbox(self, messaggio):
        frame = self.desktop.ActiveFrame
        if frame.ActiveFrame:
            # top window is a subdocument
            frame = frame.ActiveFrame
        win = frame.ComponentWindow
        box = self.tk.createMessageBox(win, MESSAGEBOX, 1, "Messaggio", messaggio)
        return box.execute()

# Qui registriamo il componente
g_ImplementationHelper = unohelper.ImplementationHelper()
g_ImplementationHelper.addImplementation(PyService, "giuserpe.esempio_1.impl", ("giuserpe.esempio_1.impl",),)
